// Bitmap.cpp
//
/////////////////////////////////////////////////////////////////////////////

#include "Bitmap.h"
#include <cassert>

/////////////////////////////////////////////////////////////////////////////
// initialization and cleanup
/////////////////////////////////////////////////////////////////////////////

Bitmap::Bitmap(int width, int height, int bpp)
{
	_width = width;
	_height = height;
	_bpp = bpp;

	_data = new UINT8[width*height*bpp/8];
	clear();
}

Bitmap::~Bitmap()
{
	delete[] _data;
}


void Bitmap::clear()
{
	memset(_data, 0, _width*_height*_bpp/8);
}

/////////////////////////////////////////////////////////////////////////////
// bitmap composition methods
/////////////////////////////////////////////////////////////////////////////

// compose 2 similar bitmaps
void Bitmap::copySimilar(Bitmap *source)
{
	assert((_width == source->_width) && (_height == source->_height));
	assert(_bpp == source->_bpp);

	// copy full bitmap
	memcpy(_data, source->_data, _width*_height*_bpp/8);
}

/////////////////////////////////////////////////////////////////////////////
// drawing methods are in bitmaptemplate.cpp
/////////////////////////////////////////////////////////////////////////////
