// InputPort.cpp
//
/////////////////////////////////////////////////////////////////////////////

#include <cassert>
#include "InputPort.h"

/////////////////////////////////////////////////////////////////////////////
// initialization and cleanup
/////////////////////////////////////////////////////////////////////////////

InputPort::InputPort(int numBits) : _bits(numBits)
{
	_value = 0;
}

InputPort::~InputPort()
{
}

/////////////////////////////////////////////////////////////////////////////
// getters & setters
/////////////////////////////////////////////////////////////////////////////

void InputPort::addBit(int bit, Inputs input, InputMode mode)
{
	assert((bit >= 0) && (bit < (int)_bits.size()));

	_bits[bit].input = input;
	_bits[bit].mode = mode;
}

/////////////////////////////////////////////////////////////////////////////
// methods
/////////////////////////////////////////////////////////////////////////////

void InputPort::reset()
{
	_value = 0;

	for (InputBits::size_type i = 0; i < _bits.size(); i++){
		_value |= (_bits[i].mode == ACTIVE_LOW) ? 1 << i : 0;
	}
}