// CoinInsertedState.cpp
//
/////////////////////////////////////////////////////////////////////////////

#include "CoinInsertedState.h"
#include "CoinInsertedSubstates.h"

GameSubstate *CoinInsertedState::substates[5];

/////////////////////////////////////////////////////////////////////////////
// initialization and cleanup
/////////////////////////////////////////////////////////////////////////////

CoinInsertedState::CoinInsertedState()
{
	substate = 0;

	substates[0] = new CoinInsertedShowInfoSubstate();
	substates[1] = new CoinInsertedWaitForStartSubstate();
	substates[2] = new CoinInsertedPrepareFirstLevelSubstate ();
	substates[3] = 0;
	substates[4] = new CoinInsertedChangeToPlayingSubstate();
}

CoinInsertedState::~CoinInsertedState()
{
	for (int i = 0; i < 5; i++){
		delete substates[i];
	}
}


void CoinInsertedState::run()
{
	// delegate the action to the substate
	if (substates[substate]){
		substates[substate]->run();
	}
}