// Difficulty.h
//
//	This class encapsulates all difficulty settings
//
/////////////////////////////////////////////////////////////////////////////

#ifndef _DIFFICULTY_H_
#define _DIFFICULTY_H_


#include "../Types.h"

class Difficulty
{
// tables
protected:
	struct patternsAndOrientationChanges {
		UINT32 movBitPatterns[7];	// movement bit patterns
		int orientationChanges[7];	// ghost counters for orientation changes
	};

	// difficulty tables
	static int difficultyTable[21][6];
	static patternsAndOrientationChanges movPatternsOrientationChanges[7];
	static int ghostCntExitHome[4][3];
	static int remainingPillsDifFlags[8][2];
	static int ghostTimeInPanicState[9];
	static int ghostUnitsExitHome[3];

public:
	static int normalDifSettings[];
	static int hardDifSettings[];

// methods
protected:
	static void setMovementBitPatternsAndOrientationChanges(int entry);
	static void setGhostsOutOfHomeCounters(int entry);

public:
	static void setDifficultySettings(int entry);
};

#endif	// _DIFFICULTY_H_