// GameSettings.h
//
//	Class that has the current settings (DIPSW dependant) and processes coins
//
/////////////////////////////////////////////////////////////////////////////

#ifndef _GAME_SETTINGS_H_
#define _GAME_SETTINGS_H_


enum CoinsPerCredit {
	COINS = 0,
	CREDITS = 1
};

class GameSettings
{
protected:
	// for new credit check
	int accumulatedCoins;
	int coinsInserted;
	int lastServices, lastCoins1, lastCoins2;

// fields
public:
	int credits;

	// settings
	int coinsPerCredit[2];
	int lives;
	int bonusLife;
	bool alternateGhostNames;
	int *difficulty;

// methods:
protected:
	void checkForCredit();

public:
	void getSettings();
	void checkForCoinInserted();
	void checkForNewCredit();

	// initialization and cleanup
	GameSettings();
	~GameSettings();
	void resetState();
};

#endif	// _GAME_SETTINGS_H_