// GameState.h
//
//	Class that defines the interface for all game states and substates
//
/////////////////////////////////////////////////////////////////////////////

#ifndef _GAME_STATE_H_
#define _GAME_STATE_H_


class GameState
{
// fields:
public:
	int substate;

// methods
public:
	virtual void run() = 0;

	// initialization and cleanup
	GameState(){}
	virtual ~GameState(){}
};


class GameSubstate
{
// methods
public:
	virtual void run() = 0;

	// initialization and cleanup
	GameSubstate(){}
	virtual ~GameSubstate(){}
};

class NopState : public GameState
{
// methods
public:
	virtual void run() {}
};

#endif	// _GAME_STATE_H_