// InitSubstate.cpp
//
/////////////////////////////////////////////////////////////////////////////

#include "InitSubstate.h"
#include "Video.h"
#include "Game.h"
#include "Writer.h"

void InitSubstate::run()
{
	// init VRAM and CRAM
	Video::clearVRAM(false);
	Video::clearCRAM();
	Video::initCRAM(0);

	// read DIPSW and save current settings
	theGame->settings.getSettings();

	// init and print scores
	Writer::initAndPrintScores();

	// init pacman and ghosts positions, tile positions, orientation vars and sprite data
	theGame->initCharacterState(false);

	// reset pacman, fruit and ghost positions
	theGame->resetCharacterPositions();

	// changes to demo state
	theGame->state = DEMO;
}
