// ScheduledTasks.cpp
//
/////////////////////////////////////////////////////////////////////////////

#include "Game.h"
#include "GameState.h"
#include "ScheduledTasks.h"
#include "Writer.h"


void IncrementPlayingSubstate::execute()
{
	theGame->states[PLAYING]->substate++;
}

void IncrementCoinInsertedSubstate::execute()
{
	theGame->states[COIN_INSERTED]->substate++;
}

void IncrementDemoSubstate::execute()
{
	theGame->states[DEMO]->substate++;
}

void IncrementGhostDeadSubstate::execute()
{
	theGame->ghostDeadAnimState++;
}

void ClearFruit::execute()
{
	theGame->fruitPosition = 0;
	theGame->fruitEntry = 0;
}

void ClearFruitPoints::execute()
{
	// in demo, clear only 2 positions because otherwise we delete GAME OVER
	Writer::printString((theGame->state == DEMO) ? 0x9b : 0xa2);
}

void ClearReadyMessage::execute()
{
	// remove ready message
	Writer::printString(0x86);
}

void IncrementCutscene1Substate::execute()
{
	theGame->cutsceneState[0]++;
}

void IncrementCutscene2Substate::execute()
{
	theGame->cutsceneState[1]++;
}

void IncrementCutscene3Substate::execute()
{
	theGame->cutsceneState[2]++;
}
