// Task.h
//
//	Class that models an scheduled task in the game
//
/////////////////////////////////////////////////////////////////////////////

#ifndef _TASK_H_
#define _TASK_H_


#include "ScheduledTask.h"

class Task
{
// fields
protected:
	// all possible tasks
	static ScheduledTask *tasks[10];

public:
	int id;		// task id

	// task time
	enum TimeUnits {
		TEN_HUNDREDTHS = 1,
		SECONDS = 2,
		TEN_SECONDS = 3
	};
	TimeUnits timeUnits;
	int remainingUnits;

// methods
public:
	// initialization and cleanup
	Task(int taskId, TimeUnits units, int time);
	~Task();
	static void initScheduledTasksList();
	static void endScheduledTasksList();

	void execute();
};

#endif