// Video.h
//
//	Handles all VRAM/CRAM tile operations
//
/////////////////////////////////////////////////////////////////////////////

#ifndef _VIDEO_H_
#define _VIDEO_H_


class Video
{
// fields
public:
	static int pillOffsets[];

// methods
protected:
	static void draw2x2Tile(int offset, int tile);
	static void clear2x2Tile(int offset, int tile);
	static void set2x2TileColor(int offset, int color);

public:
	static void pos2TilePos(int posX, int posY, int &tilePosX, int &tilePosY);
	static int tilePos2ScreenCoord(int tilePosX, int tilePosY);

	static void clearVRAM(bool gamePlayAreaOnly);
	static void clearCRAM();
	static void initCRAM(int mode);
	static void initLivesCRAM();
	static void restorePlayerTextCRAM();

	static void drawTileGhost(int offset, int color);
	static void drawLevelFruits();
	static void drawLives(int lives);
	static void drawInvisibleMiniLevel();
	static void drawGameLevel();
	static void drawPlayerPills();
	static void clearLevelPills();
};

#endif	// _VIDEO_H_